Index: src/Atom/Makefile.am
===================================================================
--- src/Atom/Makefile.am	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Atom/Makefile.am	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -29,9 +29,18 @@
   Atom/TesselPoint.hpp
 
+COPYATOMSSOURCE = \
+	Atom/CopyAtoms/CopyAtoms_SaturateDanglingBonds.cpp \
+	Atom/CopyAtoms/CopyAtoms_withBonds.cpp
+
+COPYATOMSHEADER = \
+	Atom/CopyAtoms/CopyAtoms_SaturateDanglingBonds.hpp \
+	Atom/CopyAtoms/CopyAtoms_Simple.hpp \
+	Atom/CopyAtoms/CopyAtoms_withBonds.hpp \
+	Atom/CopyAtoms/CopyAtomsInterface.hpp
 
 noinst_LTLIBRARIES += libMolecuilderAtom.la
 libMolecuilderAtom_la_includedir = $(includedir)/MoleCuilder/Atom/
 
-nobase_libMolecuilderAtom_la_include_HEADERS = ${ATOMHEADER}
+nobase_libMolecuilderAtom_la_include_HEADERS = $(ATOMHEADER) $(COPYATOMSHEADER) 
 
 ## Define the source file list for the "libexample-@MOLECUILDER_API_VERSION@.la"
@@ -43,5 +52,5 @@
 ## from each source file.  Note that it is not necessary to list header files
 ## which are already listed elsewhere in a _HEADERS variable assignment.
-libMolecuilderAtom_la_SOURCES = ${ATOMSOURCE}
+libMolecuilderAtom_la_SOURCES = $(ATOMSOURCE) $(COPYATOMSSOURCE)
 
 ## Instruct libtool to include ABI version information in the generated shared
Index: src/Atom/unittests/CopyAtomsInterfaceUnitTest.cpp
===================================================================
--- src/Atom/unittests/CopyAtomsInterfaceUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Atom/unittests/CopyAtomsInterfaceUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,136 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * CopyAtomsInterfaceUnitTest.cpp
+ *
+ *  Created on: Mar 17, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CopyAtomsInterfaceUnitTest.hpp"
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+#include <iostream>
+
+#include "CodePatterns/Log.hpp"
+
+#include "Atom/atom.hpp"
+#include "Atom/CopyAtoms/CopyAtomsInterface.hpp"
+#include "Atom/CopyAtoms/CopyAtoms_Simple.hpp"
+#include "Atom/CopyAtoms/CopyAtoms_withBonds.hpp"
+#include "Bond/bond.hpp"
+#include "World.hpp"
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+/********************************************** Test classes **************************************/
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( CopyAtomsInterfaceTest );
+
+// set up and tear down
+void CopyAtomsInterfaceTest::setUp()
+{
+  setVerbosity(5);
+
+  for(int i=0;i<ATOM_COUNT;++i){
+    atoms[i]= World::getInstance().createAtom();
+    atomIds[i]= atoms[i]->getId();
+  }
+}
+
+void CopyAtomsInterfaceTest::tearDown()
+{
+  World::purgeInstance();
+}
+
+/** Unit test on whether CopyAtomsInterface::operator() works as expected.
+ *
+ */
+void CopyAtomsInterfaceTest::CopyAtomsInterfaceOperatorTest()
+{
+  CopyAtomsInterface copyMethod;
+  CopyAtomsInterface::AtomVector atomVec(atoms, atoms+ATOM_COUNT);
+
+  copyMethod(atomVec);
+
+  CPPUNIT_ASSERT_EQUAL( (size_t)2, World::getInstance().getAllAtoms().size() );
+  CPPUNIT_ASSERT_EQUAL( (size_t)2, atomVec.size() );
+  CPPUNIT_ASSERT_EQUAL( (size_t)2, copyMethod.CopiedAtoms.size() );
+  CPPUNIT_ASSERT_EQUAL( (atom *) NULL, copyMethod.CopiedAtoms[0] );
+}
+
+/** Unit test on whether CopyAtoms_Simple::operator() works as expected.
+ *
+ */
+void CopyAtomsInterfaceTest::CopyAtoms_SimpleOperatorTest()
+{
+  CopyAtoms_Simple copyMethod;
+  CopyAtomsInterface::AtomVector atomVec(atoms, atoms+ATOM_COUNT);
+
+  copyMethod(atomVec);
+
+  CPPUNIT_ASSERT_EQUAL( (size_t)4, World::getInstance().getAllAtoms().size() );
+  CPPUNIT_ASSERT_EQUAL( (size_t)2, atomVec.size() );
+  CPPUNIT_ASSERT_EQUAL( (size_t)2, copyMethod.CopiedAtoms.size() );
+  CPPUNIT_ASSERT( copyMethod.CopiedAtoms[0] != NULL );
+}
+
+/** Unit test on whether CopyAtoms_withBonds::operator() works as expected.
+ *
+ */
+void CopyAtomsInterfaceTest::CopyAtoms_withBondsOperatorTest()
+{
+  CopyAtoms_withBonds copyMethod;
+  {
+    CopyAtomsInterface::AtomVector atomVec(atoms, atoms+ATOM_COUNT);
+    CPPUNIT_ASSERT_EQUAL( (size_t)2, atomVec.size() );
+
+    copyMethod(atomVec);
+
+    CPPUNIT_ASSERT_EQUAL( (size_t)4, World::getInstance().getAllAtoms().size() );
+    CPPUNIT_ASSERT_EQUAL( (size_t)2, copyMethod.CopiedAtoms.size() );
+    CPPUNIT_ASSERT( copyMethod.CopiedAtoms[0] != NULL );
+    CPPUNIT_ASSERT( copyMethod.CopiedAtoms[1] != NULL );
+    CPPUNIT_ASSERT_EQUAL( copyMethod.CopiedAtoms, copyMethod.getCopiedAtoms() );
+  }
+
+  // create bonds
+  {
+    atoms[0]->addBond( (size_t)0, atoms[1]);
+    const BondList & ListOfBonds = atoms[0]->getListOfBonds();
+    CPPUNIT_ASSERT( !ListOfBonds.empty() );
+    const bond * const _bond = *ListOfBonds.begin();
+    CPPUNIT_ASSERT( _bond->GetOtherAtom(atoms[0]) == atoms[1] );
+  }
+  {
+    CopyAtomsInterface::AtomVector atomVec(atoms, atoms+ATOM_COUNT);
+    CPPUNIT_ASSERT_EQUAL( (size_t)2, atomVec.size() );
+
+    copyMethod(atomVec);
+
+    CPPUNIT_ASSERT_EQUAL( (size_t)6, World::getInstance().getAllAtoms().size() );
+    CPPUNIT_ASSERT_EQUAL( (size_t)2, copyMethod.CopiedAtoms.size() );
+    CPPUNIT_ASSERT( copyMethod.CopiedAtoms[0] != NULL );
+    CPPUNIT_ASSERT( copyMethod.CopiedAtoms[1] != NULL );
+    const BondList & ListOfBonds = copyMethod.CopiedAtoms[0]->getListOfBonds();
+    CPPUNIT_ASSERT( !ListOfBonds.empty() );
+    const bond * const _bond = *ListOfBonds.begin();
+    CPPUNIT_ASSERT( _bond->GetOtherAtom(copyMethod.CopiedAtoms[0]) == copyMethod.CopiedAtoms[1] );
+  }
+}
+
+
Index: src/Atom/unittests/CopyAtomsInterfaceUnitTest.hpp
===================================================================
--- src/Atom/unittests/CopyAtomsInterfaceUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Atom/unittests/CopyAtomsInterfaceUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,47 @@
+/*
+ * CopyAtomsInterfaceUnitTest.hpp
+ *
+ *  Created on: Mar 17, 2012
+ *      Author: heber
+ */
+
+#ifndef COPYATOMSINTERFACEUNITTEST_HPP_
+#define COPYATOMSINTERFACEUNITTEST_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include <cppunit/extensions/HelperMacros.h>
+
+#include "types.hpp"
+
+// we prefer enum over define
+enum { ATOM_COUNT = 2 };
+
+class atom;
+
+class CopyAtomsInterfaceTest : public CppUnit::TestFixture
+{
+  CPPUNIT_TEST_SUITE( CopyAtomsInterfaceTest );
+  CPPUNIT_TEST ( CopyAtomsInterfaceOperatorTest );
+  CPPUNIT_TEST ( CopyAtoms_SimpleOperatorTest );
+  CPPUNIT_TEST ( CopyAtoms_withBondsOperatorTest );
+  CPPUNIT_TEST_SUITE_END();
+
+public:
+  void setUp();
+  void tearDown();
+
+  void CopyAtomsInterfaceOperatorTest();
+  void CopyAtoms_SimpleOperatorTest();
+  void CopyAtoms_withBondsOperatorTest();
+
+private:
+  atom *atoms [ATOM_COUNT];
+  atomId_t atomIds [ATOM_COUNT];
+};
+
+#endif /* COPYATOMSINTERFACEUNITTEST_HPP_ */
Index: src/Atom/unittests/Makefile.am
===================================================================
--- src/Atom/unittests/Makefile.am	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Atom/unittests/Makefile.am	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -4,12 +4,15 @@
 ATOMTESTSSOURCES = \
 	../Atom/unittests/AtomObserverUnitTest.cpp \
+	../Atom/unittests/CopyAtomsInterfaceUnitTest.cpp \
 	stubs/ObserverStub.cpp
 
 ATOMTESTSHEADERS = \
 	../Atom/unittests/AtomObserverUnitTest.hpp \
+	../Atom/unittests/CopyAtomsInterfaceUnitTest.hpp \
 	stubs/ObserverStub.hpp
 
 ATOMTESTS = \
-  AtomObserverUnitTest
+  AtomObserverUnitTest \
+  CopyAtomsInterfaceUnitTest
 
 TESTS += $(ATOMTESTS)
@@ -35,4 +38,8 @@
 AtomObserverUnitTest_LDADD = ${ATOMTESTLIBS}
 
+CopyAtomsInterfaceUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
+	../Atom/unittests/CopyAtomsInterfaceUnitTest.cpp \
+	../Atom/unittests/CopyAtomsInterfaceUnitTest.hpp
+CopyAtomsInterfaceUnitTest_LDADD = ${ATOMTESTLIBS}
 
 
Index: src/AtomIdSet.cpp
===================================================================
--- src/AtomIdSet.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/AtomIdSet.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,202 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * AtomIdSet.cpp
+ *
+ *  Created on: Feb 21, 2012
+ *      Author: heber
+ */
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "AtomIdSet.hpp"
+
+#include <boost/foreach.hpp>
+
+#include "Atom/atom.hpp"
+#include "Descriptors/AtomIdDescriptor.hpp"
+#include "World.hpp"
+
+atom * FromIdToAtom::operator()(atomId_t id) const {
+  return World::getInstance().getAtom(AtomById(id));
+}
+
+/** Constructor for class AtomIdSet.
+ *
+ * @param _atoms atoms to put into this set
+ */
+AtomIdSet::AtomIdSet(const atomIdSet &_atoms) :
+    atoms(_atoms)
+{}
+
+/** Constructor for class AtomIdSet.
+ *
+ * @param _atoms atoms to put into this set
+ */
+AtomIdSet::AtomIdSet(const std::vector<atom *> &_atoms)
+{
+  BOOST_FOREACH(const atom * _atom, _atoms) {
+    insert(_atom->getId());
+  }
+}
+
+/** Constructor for class AtomIdSet.
+ *
+ */
+AtomIdSet::AtomIdSet()
+{}
+
+/** Destructor for class AtomIdSet.
+ *
+ */
+AtomIdSet::~AtomIdSet()
+{}
+
+/** Returns iterator to first atim via a transform_iterator.
+ *
+ * @return iterator to first atom in this set
+ */
+AtomIdSet::iterator AtomIdSet::begin(){
+  return iterator(atoms.begin(), FromIdToAtom());
+}
+
+/** Returns constant iterator to first atim via a transform_iterator.
+ *
+ * @return const iterator to first atom in this set
+ */
+AtomIdSet::const_iterator AtomIdSet::begin() const{
+  return const_iterator(atoms.begin(), FromIdToAtom());
+}
+
+/** Returns iterator to one beyond last atom via a transform_iterator.
+ *
+ * @return iterator to one beyond last atom in this set
+ */
+AtomIdSet::iterator AtomIdSet::end(){
+  return iterator(atoms.end(), FromIdToAtom());
+}
+
+/** Returns constant iterator to one beyond last atom via a transform_iterator.
+ *
+ * @return const iterator to one beyond last atom in this set
+ */
+AtomIdSet::const_iterator AtomIdSet::end() const{
+  return const_iterator(atoms.end(), FromIdToAtom());
+}
+
+/** Returns true if this set is empty.
+ *
+ * @return true - set is empty, false - there is at least one atom
+ */
+bool AtomIdSet::empty() const
+{
+  return (atoms.empty());
+}
+
+/** Returns the number of members of this set.
+ *
+ * @return number of members in set
+ */
+size_t AtomIdSet::size() const
+{
+  // set has unique members, hence just return its size
+  return atoms.size();
+}
+
+/** Returns the iterator to the atom \a *key.
+ *
+ * @param key atom to find
+ * @return iterator to atom if found, to end() - else
+ */
+AtomIdSet::const_iterator AtomIdSet::find(const atom * const key) const
+{
+  return const_iterator(atoms.find(key->getId()), FromIdToAtom());
+}
+
+/** Returns the iterator to the atom \a *key.
+ *
+ * @param id atomic id to find
+ * @return iterator to atom if found, to end() - else
+ */
+AtomIdSet::const_iterator AtomIdSet::find(const atomId_t &id) const
+{
+  return const_iterator(atoms.find(id), FromIdToAtom());
+}
+
+/** Inserts a given atom into the set.
+ *
+ * @param key atom to insert
+ * @return pair of iterator and bool that states whether element is already present (true) or not (false)
+ */
+std::pair<AtomIdSet::iterator, bool> AtomIdSet::insert(const atom * const key)
+{
+  std::pair<atomIdSet::iterator, bool> iter =
+      atoms.insert(key->getId());
+  std::pair<iterator, bool> retiter (std::make_pair(iterator(iter.first), iter.second));
+
+  return retiter;
+}
+
+/** Inserts a given atom into the set.
+ *
+ * @param id atomic id to insert
+ * @return pair of iterator and bool that states whether element is already present (true) or not (false)
+ */
+std::pair<AtomIdSet::iterator, bool> AtomIdSet::insert(const atomId_t &id)
+{
+  std::pair<atomIdSet::iterator, bool> iter =
+      atoms.insert(id);
+  std::pair<iterator, bool> retiter (std::make_pair(iterator(iter.first), iter.second));
+
+  return retiter;
+}
+
+AtomIdSet::const_iterator AtomIdSet::erase(AtomIdSet::const_iterator &loc)
+{
+  const_iterator iter = loc;
+  ++iter;
+  atom * const _atom = const_cast<atom *>(*loc);
+  atoms.erase( _atom->getId() );
+  return iter;
+}
+
+/** Erase an atom from the list.
+ *
+ * @param *key key to atom in list
+ * @return iterator to just after removed item (compliant with standard)
+ */
+AtomIdSet::const_iterator AtomIdSet::erase(const atom * const key)
+{
+  const_iterator iter = find(key);
+  if (iter != end()){
+    ++iter;
+    atoms.erase( key->getId() );
+  }
+  return iter;
+}
+
+/** Erase an atom from the list.
+ *
+ * @param id atomic id atom in list to erase
+ * @return iterator to just after removed item (compliant with standard)
+ */
+AtomIdSet::const_iterator AtomIdSet::erase(const atomId_t &id)
+{
+  atomIdSet::const_iterator iter = atoms.find(id);
+  if (iter != atoms.end()){
+    ++iter;
+    atoms.erase( id );
+  }
+  return iterator(iter, FromIdToAtom());
+}
Index: src/AtomIdSet.hpp
===================================================================
--- src/AtomIdSet.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/AtomIdSet.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,76 @@
+/*
+ * AtomIdSet.hpp
+ *
+ *  Created on: Feb 21, 2012
+ *      Author: heber
+ */
+
+#ifndef ATOMIDSET_HPP_
+#define ATOMIDSET_HPP_
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <boost/iterator/transform_iterator.hpp>
+
+#include <set>
+#include <vector>
+
+#include "types.hpp"
+
+class atom;
+struct FromIdToAtom :
+  public std::unary_function<atom *, atomId_t>
+{
+    atom * operator()(atomId_t id) const;
+};
+
+/** AtomIdSet is a set of atomic ids that however behave as a set of atoms.
+ *
+ * This class represents an iterable set of atoms that is however only stored as
+ * ids internally.
+ */
+class AtomIdSet
+{
+public:
+  typedef std::set<atomId_t> atomIdSet;
+  typedef boost::transform_iterator<FromIdToAtom, atomIdSet::iterator, atom *, atomId_t> iterator;
+  typedef boost::transform_iterator<FromIdToAtom, atomIdSet::const_iterator, const atom *, atomId_t const &> const_iterator;
+
+  AtomIdSet(const atomIdSet &_atoms);
+  AtomIdSet(const std::vector<atom *> &_atoms);
+  AtomIdSet();
+  ~AtomIdSet();
+
+  iterator begin();
+  const_iterator begin() const;
+  iterator end();
+  const_iterator end() const;
+  bool empty() const;
+  size_t size() const;
+  const_iterator find(const atom * const key) const;
+  const_iterator find(const atomId_t &id) const;
+  std::pair<iterator, bool> insert(const atom * const key);
+  std::pair<iterator, bool> insert(const atomId_t &id);
+  const_iterator erase(const_iterator &loc);
+  const_iterator erase(const atom * const key);
+  const_iterator erase(const atomId_t &id);
+
+  /** Getter for internal set of atoms.
+   *
+   * @return set of atomic ids
+   */
+  const atomIdSet & getAtomIds() const {
+    return atoms;
+  }
+
+private:
+  //!> internal atoms stored by their ids
+  atomIdSet atoms;
+};
+
+
+#endif /* ATOMIDSET_HPP_ */
Index: src/Descriptors/AtomShapeDescriptor.cpp
===================================================================
--- src/Descriptors/AtomShapeDescriptor.cpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Descriptors/AtomShapeDescriptor.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -35,6 +35,29 @@
 }
 
+atom* AtomShapeDescriptor_impl::find(){
+  LinkedCell::LinkedCell_View view = World::getInstance().getLinkedCell(shape.getRadius());
+  LinkedCell::LinkedList list = view.getPointsInsideSphere(shape.getRadius(), shape.getCenter());
+  for (LinkedCell::LinkedList::iterator iter = list.begin(); iter != list.end(); ++iter) {
+    atom * const _atom = static_cast<atom *>(const_cast<TesselPoint *>(*iter));
+    if (shape.isInside(_atom->getPosition()))
+      return _atom;
+  }
+  return NULL;
+}
 
-AtomDescriptor AtomByShape(const Shape &shape){
+std::vector<atom*> AtomShapeDescriptor_impl::findAll(){
+  LinkedCell::LinkedCell_View view = World::getInstance().getLinkedCell(shape.getRadius());
+  LinkedCell::LinkedList list = view.getPointsInsideSphere(shape.getRadius(), shape.getCenter());
+  std::vector<atom*> res;
+  for (LinkedCell::LinkedList::iterator iter = list.begin(); iter != list.end(); ++iter) {
+    atom * const _atom = static_cast<atom *>(const_cast<TesselPoint *>(*iter));
+    if (shape.isInside(_atom->getPosition()))
+      res.push_back(_atom);
+  }
+  return res;
+}
+
+
+AtomDescriptor AtomsByShape(const Shape &shape){
   return AtomDescriptor(AtomDescriptor::impl_ptr(new AtomShapeDescriptor_impl(shape)));
 }
Index: src/Descriptors/AtomShapeDescriptor.hpp
===================================================================
--- src/Descriptors/AtomShapeDescriptor.hpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Descriptors/AtomShapeDescriptor.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -20,5 +20,5 @@
 class Shape;
 
-AtomDescriptor AtomByShape(const Shape &shape);
+AtomDescriptor AtomsByShape(const Shape &shape);
 
 #endif /* ATOMSHAPEDESCRIPTOR_HPP_ */
Index: src/Descriptors/AtomShapeDescriptor_impl.hpp
===================================================================
--- src/Descriptors/AtomShapeDescriptor_impl.hpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Descriptors/AtomShapeDescriptor_impl.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -27,4 +27,7 @@
   bool predicate(std::pair<atomId_t,atom*> atom);
 private:
+  virtual atom* find();
+  virtual std::vector<atom*> findAll();
+
   Shape shape;
 };
Index: src/Filling/Cluster.cpp
===================================================================
--- src/Filling/Cluster.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Cluster.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,225 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * Cluster.cpp
+ *
+ *  Created on: Jan 16, 2012
+ *      Author: heber
+ */
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include <algorithm>
+#include <boost/bind.hpp>
+#include <boost/foreach.hpp>
+
+#include "Cluster.hpp"
+
+#include "CodePatterns/Assert.hpp"
+#include "CodePatterns/Log.hpp"
+
+#include "Atom/atom.hpp"
+#include "Descriptors/AtomIdDescriptor.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Shapes/ShapeOps.hpp"
+#include "World.hpp"
+
+/** Constructor for class Cluster.
+ *
+ * @param _s Shape of this Cluster
+ */
+Cluster::Cluster(const Shape & _s) :
+    s(_s)
+{}
+
+/** Copy Constructor for class Cluster.
+ *
+ * Here, we do not check whether we atomds reside in the Shape or not, as
+ * this should have been validated in the instance to copy \a _cluster.
+ *
+ * @param _cluster instance to copy
+ */
+Cluster::Cluster(const Cluster & _cluster) :
+    atoms(_cluster.atoms),
+    s(_cluster.s)
+{}
+
+/** Constructor for class Cluster.
+ *
+ * @param _atoms list of atoms to place in this cluster
+ * @param _s Shape of this Cluster
+ */
+Cluster::Cluster(const atomIdSet & _atoms, const Shape & _s) :
+    s(_s)
+{
+  // make sure only those atoms are in Cluster that are also inside its Shape
+  std::vector<atomId_t> tempIds(_atoms.size(), (size_t)-1);
+  std::vector<atomId_t>::iterator iter =
+      std::remove_copy_if( _atoms.begin(), _atoms.end(), tempIds.begin(),
+          !boost::bind(&Cluster::IsInShape, this, _1) );
+  tempIds.erase( iter, tempIds.end() );
+  ASSERT( tempIds.size() == _atoms.size(),
+      "Cluster::Cluster() - at least one atom is not inside the Shape.");
+  atoms.insert( tempIds.begin(), tempIds.end() );
+  LOG(1, "INFO: New cluster has " << atoms.size() << " atoms.");
+}
+
+
+/** Destructor for class Cluster.
+ *
+ */
+Cluster::~Cluster()
+{}
+
+/** Inserts an atomic by its \a id into the Cluster.
+ *
+ * We check whether the atom is inside the given Shape \a s.
+ *
+ * @param id id to insert
+ */
+void Cluster::insert(const atomId_t id)
+{
+  const bool status = IsInShape(id);
+  ASSERT(status,
+      "Cluster::insert() - atomic id "+toString(id)+" is not contained in Shape.");
+  if (status) {
+    std::pair<atomIdSet::iterator, bool> inserter = atoms.insert(id);
+    ASSERT(inserter.second,
+        "Cluster::insert() - atomic id "+toString(id)+" is already present.");
+  }
+}
+
+/** Remove atom by its \a id from the cluster.
+ *
+ * @param id atom to remove
+ */
+void Cluster::erase(const atomId_t id)
+{
+  atomIdSet::iterator iter = atoms.find(id);
+  ASSERT(iter != atoms.end(),
+      "Cluster::erase() - atomic id "+toString(id)+" unknown in this Cluster.");
+  if (iter != atoms.end())
+    atoms.erase(iter);
+}
+
+/** Checks whether a given atom is within the shape \a s.
+ *
+ * @param id atomic id to check
+ * @return true - is in Shape, false - is not contained (or does not exist)
+ */
+bool Cluster::IsInShape(const atomId_t id) const
+{
+  const atom * const _atom = getAtomById(id);
+  if (_atom != NULL)
+    return s.isInside(_atom->getPosition());
+  else
+    return false;
+}
+
+/** Helper function for looking up atomic reference by its id.
+ *
+ * @param id id to look up
+ * @return reference to atom with this id
+ */
+atom * const Cluster::getAtomById(const atomId_t id) const
+{
+  atom * const _atom = World::getInstance().getAtom(AtomById(id));
+  ASSERT(_atom != NULL,
+      "Cluster::getAtomById() - id "+toString(id)+" is unknown to World.");
+  return _atom;
+}
+
+bool isNullAtom(const atom* _atom) {
+  return _atom == NULL;
+}
+
+/** Getter for the underlying true atoms refs.
+ *
+ * @return AtomVector filled with looked-up atom references
+ */
+Cluster::AtomVector Cluster::getAtomRefs() const
+{
+  AtomVector atomVector;
+  atomVector.reserve(atoms.size());
+  BOOST_FOREACH(atomId_t _id, atoms) {
+    atom * const _atom = World::getInstance().getAtom(AtomById(_id));
+    if (_atom != NULL)
+      atomVector.push_back( _atom );
+    else
+      ASSERT( false, "Cluster::getAtomRefs() - unknown id "+toString(_id)+".");
+  }
+  return atomVector;
+}
+
+/** Clone function for this instance.
+ *
+ * @param copyMethod functor that knows how to copy atoms
+ * @param offset Vector to translate new cluster relative to old one
+ * @return another instance with newly allocated atoms
+ */
+ClusterInterface::Cluster_impl Cluster::clone(
+    CopyAtomsInterface& copyMethod,
+    const Vector &offset) const
+{
+  LOG(2, "INFO: Clone this cluster with " << atoms.size() << " atoms.");
+  /// get another cluster instance
+  Cluster * clonedInstance = new Cluster(::translate(getShape(), offset));
+
+  /// copy and move atoms
+  copyMethod(getAtomRefs());
+  AtomVector CopiedAtoms = copyMethod.getCopiedAtoms();
+  BOOST_FOREACH( atom *_atom, CopiedAtoms) {
+    _atom->setPosition( _atom->getPosition() + offset );
+  }
+
+  /// fill copied atoms into new instance
+  // dont use a set here, makes life hard with STL algos
+  std::vector<atomId_t> Copies(CopiedAtoms.size(), (size_t)-1);
+  std::transform(CopiedAtoms.begin(), CopiedAtoms.end(), Copies.begin(),
+      boost::bind(&atom::getId, _1) );
+  clonedInstance->atoms.insert(Copies.begin(), Copies.end());
+
+  return ClusterInterface::Cluster_impl(clonedInstance);
+}
+
+/** Translate atoms inside Cluster and Shape.
+ *
+ * @param offset offset to translate by
+ */
+void Cluster::translate(const Vector &offset)
+{
+  // move atoms
+  AtomVector atomVector = getAtomRefs();
+  BOOST_FOREACH(atom *_atom, atomVector) {
+    _atom->setPosition(_atom->getPosition()+offset);
+  }
+  // translate shape
+  s = ::translate(s, offset);
+}
+
+/** Transform atoms inside Cluster and Shape.
+ *
+ * @param M transformation matrix
+ */
+void Cluster::transform(const RealSpaceMatrix &M)
+{
+  // transform atoms
+  AtomVector atomVector = getAtomRefs();
+  BOOST_FOREACH(atom *_atom, atomVector) {
+    _atom->setPosition( M * _atom->getPosition() );
+  }
+  // translate shape
+  s = ::transform(s, M);
+}
Index: src/Filling/Cluster.hpp
===================================================================
--- src/Filling/Cluster.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Cluster.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,89 @@
+/*
+ * Cluster.hpp
+ *
+ *  Created on: Jan 16, 2012
+ *      Author: heber
+ */
+
+#ifndef CLUSTER_HPP_
+#define CLUSTER_HPP_
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "types.hpp"
+
+#include <set>
+
+#include "ClusterInterface.hpp"
+
+#include "Atom/CopyAtoms/CopyAtomsInterface.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Shapes/Shape.hpp"
+
+class atom;
+class RealSpaceMatrix;
+
+/** A Cluster is a set of atoms within a given Shape that contains them.
+ *
+ */
+class Cluster : public ClusterInterface
+{
+  //!> grant unit test access
+  friend class ClusterTest;
+public:
+  typedef std::set<atomId_t> atomIdSet;
+  typedef std::vector<atom *> AtomVector;
+
+  Cluster(const Cluster & _cluster);
+  Cluster(const Shape &s);
+  Cluster(const atomIdSet &atoms, const Shape &s);
+  ~Cluster();
+
+  void insert(const atomId_t id);
+  void erase(const atomId_t id);
+
+  /** Getter for the internal set of atomic ids.
+   *
+   * @return atomIdSet with \a atoms
+   */
+  const atomIdSet & getAtomIds() const { return atoms; }
+
+  Cluster_impl clone(CopyAtomsInterface& copyMethod, const Vector &offset = zeroVec) const;
+
+  void translate(const Vector &offset);
+
+  void transform(const RealSpaceMatrix &M);
+
+  bool isInside(const atomId_t id) const {
+    return IsInShape(id);
+  }
+
+  /** Getter for the internal Shape.
+   *
+   * @return Shape \a s
+   */
+  const Shape& getShape() const { return s; }
+
+private:
+  /** Getter for the contained atoms.
+   *
+   * @return vector of atomic refs
+   */
+  AtomVector getAtomRefs() const;
+
+  //!> do not allow Cluster without Shape
+  Cluster();
+
+  bool IsInShape(const atomId_t id) const;
+  atom * const getAtomById(const atomId_t id) const;
+
+  atomIdSet atoms;
+  Shape s;
+};
+
+
+#endif /* CLUSTER_HPP_ */
Index: src/Filling/ClusterInterface.hpp
===================================================================
--- src/Filling/ClusterInterface.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/ClusterInterface.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,108 @@
+/*
+ * ClusterInterface.hpp
+ *
+ *  Created on: Jan 20, 2012
+ *      Author: heber
+ */
+
+#ifndef CLUSTERINTERFACE_HPP_
+#define CLUSTERINTERFACE_HPP_
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <boost/shared_ptr.hpp>
+#include <set>
+
+#include "AtomIdSet.hpp"
+#include "types.hpp"
+
+class atom;
+class CopyAtomsInterface;
+class RealSpaceMatrix;
+class Shape;
+class Vector;
+
+/** This is the interface class for clusters.
+ *
+ * Clusters are containers for \refAtomIdSet that make sure that within a given
+ * shape each of the atoms in the \ref AtomIdSet is contained and none else.
+ *
+ * We need this ClusterInterface to allow for ClusterInterface::clone() to not
+ * return a pointer but a boost::shared_ptr which is much cleaner in terms of
+ * memory management.
+ *
+ */
+class ClusterInterface
+{
+public:
+  //!> typedef for pointer to ClusterInterface-compatible instances
+  typedef boost::shared_ptr<ClusterInterface> Cluster_impl;
+  typedef AtomIdSet::atomIdSet atomIdSet;
+
+  virtual ~ClusterInterface() {}
+
+  /** Getter for the set of atomic ids associated to the cluster.
+   *
+   * @return set of atomic ids
+   */
+  virtual const atomIdSet & getAtomIds() const=0;
+
+  /** Getter for the set of atoms associated to the cluster.
+   *
+   * @return set of atoms
+   */
+  AtomIdSet getAtoms() const
+  {
+    return AtomIdSet(getAtomIds());
+  }
+
+  /** Getter for the cluster's Shape.
+   *
+   * @return Shape \a s
+   */
+  virtual const Shape& getShape() const=0;
+
+  /** Clones this cluster.
+   *
+   * We copy the shape and we copy all contained atoms in such a way as
+   * functor \a copyMethod does. We also translate atoms by \a offset
+   * eventually.
+   *
+   * @param copyMethod functor that knows how to copy the atoms
+   * @param offset translational offset for contained atoms
+   * @return reference to the clone cluster
+   */
+  virtual Cluster_impl clone(CopyAtomsInterface& copyMethod, const Vector &offset) const =0;
+
+  /** Move a cluster.
+   *
+   * This moves both all contained atoms associated to the cluster and the
+   * shape itself
+   *
+   * @param offset translation vector
+   */
+  virtual void translate(const Vector &offset)=0;
+
+  /** Transforms a cluster.
+   *
+   * This transforms both all contained atoms associated to the cluster and the
+   * shape itself with respect to their spatial positions.
+   *
+   * @param M transformation matrix
+   */
+  virtual void transform(const RealSpaceMatrix &M)=0;
+
+  /** Check whether the given atom is inside the Cluster's shape.
+   *
+   * @param id atom id to check
+   * @return true - is inside cluster's shape, false - else
+   */
+  virtual bool isInside(const atomId_t id) const = 0;
+};
+
+
+#endif /* CLUSTERINTERFACE_HPP_ */
